/**
*/

#include <iostream.h>
#include <fstream.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <deffunc.h>

#include "File1Reader.h"
#include "SetCoverProblem.h"

/**
*/

void File1Reader::setFileName(char *FileName)
{  sprintf(MyFileName,"%s", FileName);
}

/**
*/

SetCoverProblem * File1Reader::read()
{  ifstream infile(MyFileName);
   int val, j,k;
   char buf[80];
   char line1[80];
   char line2[80];
   char ch;
   long int NumOfRows, NuOfVariables, NumOfNonZeros, TheBestIP;
   long int vals[4];
   long int ColumnNum, NonZeros, Profit ;
   double TheBestLP;
   int RowIndex[50];
   int Exit = 0;
   ulong i;
   
   i=j=0;

   cout << "File name : " << MyFileName << endl;

   if(infile) cout << " File is not Ok " << endl;

   while( (!infile.eof()) && (i<4))
   {  
      for(j=0;j<9;j++) 
      { infile.get( ch ); buf[j]=ch; 
	cout << j << ":" << ch << ":" ;
      }
      buf[j]=NULL;
      cout << "buf :" << buf << ":" << " int val :"<< atoi(buf) << endl;
      vals[i] = atoi(buf);
      i++;
   }

   infile.getline(buf,80);
   cout << buf << endl;
   TheBestLP = atof(buf);

   cout << endl;

   cout << " Report " << endl;
   cout << " Number of Rows      : " << vals[0] << endl;
   cout << " Number of Variables : " << vals[1] << endl;
   cout << " Number of nonzeros  : " << vals[2] << endl;
   cout << " The Best Known Ip   : " << vals[3] << endl;
   cout << " The Best Known LP   : " << TheBestLP << endl;


   SetCoverProblem *SetCoverInstance = new SetCoverProblem(vals[0],vals[1],vals[2], vals[3],TheBestLP);
   i=0;
   while(!infile.eof()&&!Exit)
   {  
      infile.getline(line1,80);
      if(infile.eof()) Exit=1;
      if(!Exit) infile.getline(line2,80);
      if(infile.eof()) Exit=1;

      if(!Exit)
      {  for(j=0;j<7;j++) buf[j] = line1[j]; buf[j]=NULL; 
         Profit = atoi(buf);
         for(j=0;j<3;j++) buf[j] = line1[j+7]; buf[j]=NULL; 
         NonZeros = atoi(buf);
         for(j=0;j<8;j++) buf[j] = line1[j+10]; buf[j]=NULL; 
         ColumnNum = atoi(buf);

         for(j=0;j<NonZeros;j++)
         {  for(k=0;k<4;k++) buf[k] = line2[k+j*4]; buf[k]=NULL;
	    RowIndex[j] = atoi(buf);
         }
      
	 (*SetCoverInstance).UpdateRow(i,NonZeros,Profit,ColumnNum,RowIndex);

         i++;
      }// end of if

   }// end of while

   infile.close();

   //(*SetCoverInstance).printRowInfo();
   SetCoverInstance->sort();

   return SetCoverInstance;

}// end of read

/**
*/

File1Reader::~File1Reader()
{
   cout << "deallocate" << endl;
}
